#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1600three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 1600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1600three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three16004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three16004xi = {
                1:'0x1553y-384z',
                2:'0x31y-1599z',
                3:'1000x1235y-180z',
                4:'1012x914y-835z',
                5:'1043x1008y-673z',
                6:'1058x1095y-489z',
                7:'1064x1182y-164z',
                8:'1065x865y-822z',
                9:'108x176y-1586z',
                10:'1099x956y-659z',
                11:'10x78y-1598z',
                12:'1115x813y-808z',
                13:'1117x1042y-474z',
                14:'1126x1126y-148z',
                15:'1153x902y-644z',
                16:'115x439y-1534z',
                17:'1174x985y-459z',
                18:'1184x1066y-132z',
                19:'1204x844y-630z',
                20:'1227x925y-443z',
                21:'1240x1004y-116z',
                22:'126x1441y-682z',
                23:'126x183y-1584z',
                24:'1278x862y-428z',
                25:'1291x938y-100z',
                26:'135x1304y-1081z',
                27:'142x447y-1529z',
                28:'145x189y-1582z',
                29:'15x20y-1599z',
                30:'163x1551y-353z',
                31:'164x1341y-856z',
                32:'165x193y-1579z',
                33:'171x453y-1524z',
                34:'17x93y-1597z',
                35:'186x195y-1576z',
                36:'18x392y-1551z',
                37:'192x1229y-1005z',
                38:'1x47y-1599z',
                39:'200x458y-1519z',
                40:'202x1439y-668z',
                41:'208x196y-1574z',
                42:'22x1333y-883z',
                43:'230x195y-1571z',
                44:'231x460y-1514z',
                45:'235x1339y-842z',
                46:'244x1544y-337z',
                47:'252x192y-1568z',
                48:'258x1227y-993z',
                49:'262x460y-1509z',
                50:'26x108y-1596z',
                51:'26x32y-1599z',
                52:'275x187y-1564z',
                53:'278x1433y-653z',
                54:'294x459y-1504z',
                55:'307x1333y-829z',
                56:'325x1221y-980z',
                57:'325x1532y-322z',
                58:'326x455y-1498z',
                59:'354x1423y-639z',
                60:'359x449y-1492z',
                61:'36x122y-1594z',
                62:'378x1323y-815z',
                63:'38x42y-1598z',
                64:'391x1212y-967z',
                65:'392x441y-1487z',
                66:'406x1516y-306z',
                67:'40x406y-1547z',
                68:'425x430y-1481z',
                69:'430x1408y-624z',
                70:'450x1309y-801z',
                71:'458x1199y-954z',
                72:'458x417y-1474z',
                73:'486x1496y-290z',
                74:'48x135y-1593z',
                75:'491x402y-1468z',
                76:'505x1390y-609z',
                77:'50x1439y-697z',
                78:'521x1291y-787z',
                79:'523x384y-1462z',
                80:'524x1182y-942z',
                81:'52x51y-1598z',
                82:'554x364y-1455z',
                83:'564x1471y-275z',
                84:'580x1367y-594z',
                85:'589x1161y-929z',
                86:'591x1269y-773z',
                87:'5x63y-1598z',
                88:'5x7y-1599z',
                89:'61x147y-1592z',
                90:'63x418y-1542z',
                91:'642x1442y-259z',
                92:'653x1340y-580z',
                93:'654x1137y-916z',
                94:'660x1243y-759z',
                95:'67x59y-1597z',
                96:'717x1108y-902z',
                97:'717x1408y-243z',
                98:'725x1309y-565z',
                99:'728x1213y-745z',
                100:'75x158y-1590z',
                101:'779x1077y-889z',
                102:'791x1371y-227z',
                103:'795x1180y-731z',
                104:'796x1274y-550z',
                105:'81x1554y-369z',
                106:'82x65y-1596z',
                107:'840x1041y-876z',
                108:'860x1142y-717z',
                109:'863x1330y-211z',
                110:'864x1235y-535z',
                111:'88x430y-1538z',
                112:'899x1002y-862z',
                113:'91x167y-1588z',
                114:'923x1101y-702z',
                115:'92x1339y-869z',
                116:'931x1192y-520z',
                117:'933x1284y-195z',
                118:'957x960y-849z',
                119:'984x1056y-688z',
                120:'996x1145y-504z',
                121:'99x70y-1595z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1600three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire1600three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE16000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE16000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE16000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE16000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE16000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three16004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE16000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE16000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE16000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three16004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three16004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE16000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE16000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE16000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1600three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                